#######################################################################
# Copyright (c) 2014 ENEO Tecnologia S.L.
# This file is part of redBorder.
# redBorder is free software: you can redistribute it and/or modify
# it under the terms of the GNU Affero General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
# redBorder is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Affero General Public License for more details.
# You should have received a copy of the GNU Affero General Public License
# along with redBorder. If not, see <http://www.gnu.org/licenses/>.
#######################################################################
module Integrations
  class CommonStrategy
    def self.strategy_name
      const_get(:NAME)
    end
  end

  class GlpiStrategy < CommonStrategy
    NAME = "glpi"
  
    def saved_params
      {
        glpi_api_token: fetch_integration_value("glpi_api_token"),
        glpi_api_url: fetch_integration_value("glpi_api_url"),
        glpi_app_token: fetch_integration_value("glpi_app_token"),
        glpi_update_periodicity: fetch_integration_value("glpi_update_periodicity"),
        glpi_update_time: fetch_integration_value("glpi_update_time")
      }
    end
  
    private
  
    def fetch_integration_value(name)
      integration = Integration.find_by(name: name)
      integration ? integration.value : nil
    end
  end
end
